/**
 * Implementiert ein Schaaf-Objekt mit den Attributen Name und Fell.
 * 
 * @author Andreas Hofmeier
 * @version 1.0
 */
public class Sheep {

	/** Das Fell des Schaafs */
	public Fur fur;

	/** Der Name des Schaafs. */
	public String name;

	/**
	 * Legt ein neues Schaaf an.
	 * @param f Das Fell des Schaafs.
	 * @param n Der Name des Schaafs.
	 */
	public Sheep(Fur f, String n) {
		fur = f;
		name = n;
	}

	/**
	 * Gibt die Daten des Schaafs aus. 
	 */
	public String toString() {
		return ("Sheep is called " + name + ", its fur`s length is "
				+ fur.length + ", its fur`s color is " + fur.color);
	}

	/**
	 * Klont das Schaaf mittels deep-copy.
	 * @return das geklonte Schaaf.
	 */
	public Sheep cloneDeep() {
	    Fur f = new Fur(this.fur.length, this.fur.color);
	    Sheep result = new Sheep(f, this.name);
	    return result;
	}

	/**
	 * Klont das Schaaf mittels shallow-copy.
	 * @return das geklonte Schaaf.
	 */
	public Sheep cloneShallow() {
	    return new Sheep(this.fur, this.name);	    
	}
}
