/**
 * Eine Testklasse, die die deep- und shallow-copy-Methoden der <code>Sheep</code>-Klasse testet.
 * @author Andreas Hofmeier
 * @version 1.0
 *
 */
public class Sheepfarm {

  /**
   * Testet die deep- und shallow-copy-Methoden der <code>Sheep</code>-Klasse.
   * @param args wird hier nicht benutzt.
   */
  public static void main(String[] args) {
    // Lege ein Schaf dolly mit einem neuen Fell-Objekt an.
    Fur furOfDolly = new Fur(10, "white");
    Sheep dolly = new Sheep(furOfDolly,"Dolly");
    
    // Klont dolly mittels Shallow-Copy
    Sheep dollyShallowClone = dolly.cloneShallow();
    
    // Klont dolly mittels Deep-Copy
    Sheep dollyDeepClone = dolly.cloneDeep();

    // Schneide und faerbe dollys Fell
    dolly.fur.cutFur();
    dolly.fur.colorFur("black");
    
    // Gib das Ergebnis aus:
    System.out.println(dolly);
    System.out.println(dollyShallowClone);
    System.out.println(dollyDeepClone);
    
    // BEOBACHTUNG: Obwohl nur das Schaaf dolly sein Fell veraendert hat, wirkt
    // sich dies auch auf den Shallow-Clone aus. Das Fell des Deep-Clones aendert
    // sich nicht.
    // GRUND: Bei der Deep-Copy, werden alle Attribute mit ebenfalls echt geklont.
    // Bei der Shallow-Copy wird dagegen nur das Sheep-Objekt geklont, waehrend
    // das Fur-Objekt das gleiche bleibt.
  }
}
